type spaceType = Plain | Water | Wall | HomeBase

type robot = int

type packageId = int

type point = (int * int)

type packageDesc = (robot option * point * int)

type package = (packageId * packageDesc)

type robotDesc = (point * packageId list)

type robotList = (robot * robotDesc) list

type packageList = (packageId * packageDesc) list

type bid = int

type space = (robot list * packageList * spaceType)

type grid = (space array) array

(* redundant data structure for easier access: grid of spaces that contain robot and package lists,
   and a list of robots including their packages and positions *)
type gameState = grid * robotList

let bid (num, _) = num
